"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const _ = require("lodash");
const vm = require("vm");
function evalInContext(code, context = {}, opts = {}) {
    const sandbox = {};
    if (context) {
        Object.keys(context).forEach((key) => {
            sandbox[key] = context[key];
        });
    }
    const resultKey = 'SAFE_EVAL_' + Math.floor(Math.random() * 1000000);
    code = `${resultKey} = (${code})`;
    sandbox[resultKey] = {};
    vm.runInNewContext(code, sandbox, opts);
    return sandbox[resultKey];
}
exports.evalInContext = evalInContext;
function deserialize(rawRules, dependencies = []) {
    let context = {};
    dependencies.forEach((path) => {
        path = path.trim();
        if (path) {
            const module = require(`${path}`);
            context = _.extend(context, module);
        }
    });
    return evalInContext(rawRules, context);
}
exports.deserialize = deserialize;
//# sourceMappingURL=deserializer.js.map